/*

    Dialogo con il BG per prelevare i dati necessari e per comunicare con le popup
    
    window.GAMinfo viene inniettato prima
    
*/

( function( info ){
    
    if( !info )return false;
    
    // Informazioni di base
    var core = info.core;
    
    // Imposto i dati di ricerca
    var all      = document.getElementsByTagName("*"),
        sources  = [],
        test 	 = new RegExp( core.proto, "gi" ),
        exts 	 = "";

	for( var i = 0; i < core.media.length; i++ ){
        
		for( var a = 0; a < core.media[i].file.length; a++ ){
            
			if( core.media[i].file[a].unc )continue;
            
			var est = core.media[i].file[a].ext.replace( "(", "" ).replace( ")", "" );
			exts += ( exts.length < 1 ) ? est : "|" + est;
		
        }
	
    }
	
    exts = new RegExp( "(" + exts + ")", "gi" );
    
    // Comunico la fine dei processi
    function _endProcess(){
        
        chrome.runtime.sendMessage( { for:info.popup, finded:sources, dialog:"End-Scanning-Advanced" } ); 
        
    };
    
    function _translate( key ){
          
        return ( key && typeof key == "string" )? chrome.i18n.getMessage( key ) : "";
            
    };
    
    // Inserisco un nuovo elemento
    function _newSource( data, ext ){
        
        if( !data || !ext )return false;
        
        sources.push( {
            
            url  : document.location.href,
            data : data,
            ext  : ext
            
        } );
        
        console.log( "Aggiungo un nuovo finded : " + sources.length );
        
    }
    
    // Segnalo l'avanzamento dei test
    function _updateScore( current, max ){
        
       chrome.runtime.sendMessage( { for:info.popup, sets:{
           
           founded : sources.length,
           current : current,
           max     : max
           
       }, dialog:"Update-Score-Advanced" } ); 
        
    }
    
    // Creo una struttura di funzioni per i vari test
    var scanner = [
      
        /*{
            
            test : function(){
                
                console.log( "Test per Meta Tags" );
                // Ricerca nei meta tags
                var objmetas = document.getElementsByTagName( "meta" ) || [];
                var tests=[
                    
                    "videourl",
                    "video_url",
                    "url_video",
                    "urlvideo",
                    "audiourl",
                    "audio_url",
                    "url_audio",
                    "urlaudio"
                
                ];
                
                var re = new RegExp( tests.join( "|" ), "gi" );

                try{
                                            
                    for( var i = 0; i < objmetas.length; i++ ){
                        
                        var attr_name = objmetas[ i ].getAttribute( "name" );
                        
                        if( attr_name && attr_name.match( re ) ){
                            
                            var attr_content = objmetas[ i ].getAttribute( "content" );
                            _newSource( attr_content, "Meta Tags" );
                            
                        }
                        
                    }
                
                    console.log( "Finded : " + sources.length );
                    
                }catch( e ){
                    
                    console.log( "Errori nei test sui meta tags" );
                    
                }
                
            }
            
        },*/
        {
            
            test : function(){
                
                console.log( "Test per Localstorage" );
                // Ricerca nel local storage
                for ( var key in localStorage ){
                    
                    var source = unescape( unescape ( localStorage[ key ] ) );
                    
                    if( source.match( test ) || source.match( exts ) ) _newSource( source, _translate( "mex58" ) );
                
                }
                
                console.log( "Finded : " + sources.length );
                
            }
            
        },
        {
            
            test : function(){
                
                console.log( "Test per i cookie" );
                // Ricerca nei cookie
                var ca = document.cookie.split( ";" );
                
                for( var i = 0; i < ca.length; i++ ){
                    
                    var c = ca[ i ].trim(),
                        v = c.split( "=" );

                    if( !v[ 0 ] || !v[ 1 ] )continue;

                    if(v[ 1 ].match( test ) || v[ 1 ].match( exts ) ){
                        
                        _newSource( v[ 1 ], _translate( "mex59" ) );
                    
                    }		
                
                }
                
                console.log( "Finded : " + sources.length );
                
            }
            
        },
        {
            
            test : function(){
                
                console.log( "Test per i contenuti degli script" );
                
                // Ricerca nei content script
                var s     = document.getElementsByTagName( "script" ),
                    open  = new RegExp( "<", "gi" ),
                    close = new RegExp( ">", "gi" );

                for( var i = 0; i < s.length; i++ ){
                    
                    var c 	= s[ i ].innerHTML.trim(),
                        spc = c.split( "\n" );
                    
                        for( var a = 0; a < spc.length; a++ ){
                            
                            var line = spc[ a ].trim();
                            
                            if( line.length > 0 && ( line.match( test ) || line.match( exts ) ) )
                                _newSource( line.replace( open, "&lt;" ).replace( close, "&gt;" ), _translate( "mex60" ) );
                            
                        }
                    
                }
                
                console.log( "Finded : " + sources.length );
                
            }
            
        },
        {
            
            test : function(){
                
                console.log( "Test per tutti gli attributi" );
                
                // Ricerca in tutti gli attributi
                for ( var i = 0, max = all.length; i < max; i++ ){
                    
                    var attrs 	= all[ i ].attributes;

                    for( var a = 0; a < attrs.length; a++ ){
                        
                        var attry = _translate( "mex61" ) + " ( " + attrs[ a ].nodeName + " )" + attrs[ a ].value;
                        
                        if( !attrs[ a ].value )continue;
                        
                        var exame = encodeURIComponent( attrs[ a ].value.trim() );
                        
                        if( exame.match( test ) || exame.match( exts ) ){
                            
                            _newSource( exame, "Tag : " + all[i].tagName );
                        
                        }
                        
                    }
                    
                }
                
                console.log( "Finded : " + sources.length );
                
            }
            
        }
        
    ];
    
    // Eseguo una serie di processi
    function _startAdvanced(){
        
        // Devo implementare i processi, fin qui tutto ok
        for( var i = 0; i < scanner.length; i++ ){
            
            scanner[ i ].test();
            _updateScore( i, scanner.length );
            
        }       
        
        _endProcess();
        
    };
    
    _startAdvanced();
    
} )( window.GAMinfo );










