
(function( D ){
	
	// Private Shared - dati identificativi di classe
	var THISCLASS = {

		version : "1.0.0.0",
		name 	: "gam-project-helper.js",

	};

	if( !D ) throw new Error( "[ " + THISCLASS.name + " ] require document loaded !" );

	// Shared - variabile di controllo per il debug, per tutte le istanze
	var debug = false;

	// Private - definisco la classe
	function ClassProjectHelper( opt ){

		// Private - settaggi
		var settings = {
            
            workers : [
                
                /*
                
                    {
                        
                        domain  : "miodominio",
                        params  : [ 
                        
                            {
                            
                                param : "affid",
                                value : "2323413"
                            
                            }
                        
                        ]
                    
                    }
                
                */
                
            ],
            classNameUpdated : "gam-project-helper",
            onClick          : function(){},
            onCreated        : function(){},
            onAdded          : function(){}
	
		};
        
        var lastscan = 0;

		// Private - funzione per il log - da eliminare se carico un Debug esterno
		function _lol( mex ){

			if( debug )console.log( "[ " + THISCLASS.name + " ] " + mex );
				
			return false;

		};
		
		// Private - utility per settare le opzioni
		function _reverseMerge( source, news ){

			source 	= source 	|| settings;
			news 	= news 		|| {};	

			for( var key in source ) {
			    
				if( source.hasOwnProperty( key ) && !( key in news )) {
			     
			    	news[ key ] = source[ key ];
			    
			    }
			  
			}
			
			return news;
		
		};

		// Private - setto le opzioni
		function _setOptions( opt ){

			_lol( "Setto le nuove opzioni" );

			opt = opt || {};

			settings = _reverseMerge( settings, opt );

		};
        
        // Private - ricava l'host da un link
        function _getHostName( link ){
            
            if( !link || typeof link != "string" )return "";
            
            link = link.trim();
            
            var a = link.split( "://" );
            if( a.length < 2 ) return "";
                
            var b = a[ 1 ].split( "/" );
            
            return ( b.length < 1 ) ? a[ 1 ] : b[ 0 ];
            
        };
        
        // Private - controlla se esiste una classe in un link
        function _islinkSigned( a ){
                        
            try{
            
                // Controllo se ho le classi
                var classes = a.getAttribute( "class" );
                if( !classes )return false;

                classes = classes.split( " " );

                for( var i = 0; i < classes.length; i++ ){

                    if( classes[ i ] == settings.classNameUpdated )return true;

                }
                
            }catch( e ){
                
                return null;
                
            }            
            
            return false;
            
        };
        
        // Private - restituisce il link transmutato
        function _transmuteLink( href, params ){
            
            var trasmuted = href;
            
            try{
               
                // Scompongo il link per ottenere i parametri
                var a = href.split( "?" );
                if( a.length != 2 )return null;
               
                var b = a[ 1 ].split( "&" );
                if( b.length < 1 )return null;
                
                _lol( "Ricevo una richiesta di transmutazione, con parametri : " + b.length );
                _lol( JSON.stringify( params ) );
               
                // Vediamo quali sono i parametri
                for( var i = 0; i < params.length; i++ ){
                   
                    var param = params[ i ].param;
                    if( !param )continue;
                    _lol( "Sottopongo : " + param );
                   
                    var value = params[ i ].value;
                    if( !value )continue;
                    _lol( "Sottopongo : " + value );
                    
                    // Controllo tutti setters
                    for( var ii = 0; ii < b.length; ii++ ){
                       
                        var couple = b[ ii ];
                       
                        // Controllo la key
                        var key = couple.split( "=" );
                        if( key.length != 2 )continue;
                       
                        // Se ho il parametro lo cambio
                        _lol( "Confronto i parametri : " + param + " / " + key[ 0 ] );
                        if( key[ 0 ] == param ){
                            
                            trasmuted = trasmuted.replace( couple, param + "=" + value );
                            _lol( "Cambio un parametro : " + couple );
                            
                        }
                       
                    }
                   
                }
             
                return ( trasmuted != href ) ? trasmuted : null;
                
            }catch( e ){
               
                return null;
                _lol( "Errori durante la transumazione : " + e.message );
               
            }
            
        };
        
        // Private - segna con una classe
        function _signLink( a ){
            
            try{
                
                var classnew = a.getAttribute( "class" ) || "";
                classnew = classnew + " " + settings.classNameUpdated;
                classnew = classnew.trim();
                            
                a.setAttribute( "class", classnew );
                _lol( "Segno un nuovo link : " + a.getAttribute( "href" ) )
                
            }catch( e ){
                
                // TODO
                
            }
            
        };
        
        // Private - aggiungo i parametri
        function _addParameters( href, params ){
            
            try{                
                // Potrebbe essere un ancor
                if( _isAncorLinkorScript( href ) )return href;
                
                // Controllo se ho la concatenazione, altrimenti aggiungo
                if( href.indexOf( "?" ) < 0 ){
                    
                    if( href.substring( href.length - 1, href.length ) != "/" )href += "/";
                        
                    href += "?";
                    
                }
                
                for( var i = 0; i < params.length; i++ ){
                   
                    var param = params[ i ].param;
                    if( !param )continue;
                   
                    var value = params[ i ].value;
                    if( !value )continue;
                    
                    if( href.indexOf( "?" ) < ( href.length - 1 ) )href += "&";
                    
                    href += param + "=" + value;
                
                }
                
                return href;
                
            }catch( e ){
                
                return href;
                
            }
            
        };
        
        // Private - controllo se è trasmutabile
        function _isAncorLinkorScript( href ){
            
            return ( typeof href == "string" && href.length > 0 && 
                    ( ( href.indexOf( "?" ) < 0 && href.indexOf( "#" ) > -1 ) || href.indexOf( "javascript:" ) == 0 ) );
            
        };
        
        // Private - controllo e aggiorno i link
        function _updateLinks(){       
            
            // Controllo se ho settato i workers iniziali e se non ho modificato i target
            if( !settings.workers || settings.workers.length < 1 )return _lol( "Non posso procedere, non ho i workers settati" );
            
            /* 
                Sembrerebbe che ho i workers, ma sono giusti ? lo vediamo avanti, per il momento
                prelevo i dati che mi servono, seleziono tutti i link
            */
            
            var allLinks = D.getElementsByTagName( "a" );
            if( !allLinks )return _lol( "Non posso procedere, non ho link nella pagina" );
            
            _lol( "Link totali : " + allLinks.length );
            
            if( allLinks.length == lastscan )return _lol( "Non controllo i link !" );
                        
            // Controllo i link ed eventualmente li modifico, non li controllo sempre tutti
            for( var i = ( lastscan > 0 ) ? lastscan - 1 : lastscan ; i < allLinks.length; i++ ){
                
                var link     = allLinks[ i ],
                    linkhref = link.getAttribute( "href" ) || "";
                
                linkhref = linkhref.trim();
                
                _lol( "Controllo il link numero : " + i );
                
                // Se è già stato segnato proseguo o se è un ancor continuo
                if( _islinkSigned( link ) || _isAncorLinkorScript( linkhref ) )continue;
                                
                // Un ciclo per i workers e controllare se lavorarci
                for( var ii = 0; ii < settings.workers.length; ii++ ){
                    
                    var worker   = settings.workers[ ii ];
                                    
                    // Controllo i parametri se giusti
                    if( linkhref.length < 1 || !worker.domain || !worker.params || worker.params.length < 1 )continue;               
                    
                    // Se il link non è un canonico devo controllare se mi trovo sul sito
                    if( linkhref.indexOf( worker.domain ) > -1 || 
                       ( linkhref.indexOf( "http" ) != 0 && D.location.href.indexOf( worker.domain ) > -1 ) ){
                        
                        // Il link rientra nei nostri target, cambio o aggiungo i parametri
                        var trasmuted = _transmuteLink( linkhref, worker.params );
                        if( trasmuted ){
                            
                            _lol( "Link transmutato : " + trasmuted );
                            
                            // Setto il nuovo link
                            link.setAttribute( "href", trasmuted );
                            
                            settings.onCreated( trasmuted );                            
                                                        
                        }else{
                            
                            // Siccome è un link con cui lavorare e non ho avuto transmutazioni, io aggiungo i parametri lo stesso
                            var newhref = _addParameters( linkhref, worker.params );
                            
                            _lol( "Link aggiornato : " + newhref );
                            
                            // Setto il nuovo link
                            link.setAttribute( "href", newhref );
                            
                            settings.onAdded( newhref );
                            
                        }
                        
                        // Segno il link con la classe
                        _signLink( link );
                        
                        // Faccio aprire il link in una finestra nuova per registrare il click
                        //link.setAttribute( "target", "_blank" );
                        
                        // Appendo l'evento con il click
                        link.addEventListener( "click", function(){
                                
                            settings.onClick( this.getAttribute( "href" ) );
                                
                        } );
                            
                        
                    }
                    
                }
                
            }
          
            // Aggiorno il contatore
            lastscan = allLinks.length;
            
        };
                
		// Public Shared - passo in modalità debug, registro gli eventi
		this.DebugMode = function( value ){

			value = value || false ;

			debug = value;

			_lol( "DebugMode : " + value );

		};
        
        // Public - aggiorno i link 
		ClassProjectHelper.prototype.UpdateLinks = function(){
            
            _lol( "Controllo la presenza di nuovi link/words in : " + D.location.href );
            settings.onClick   = ( typeof settings.onClick != "function" ) ? function(){} : settings.onClick;
            settings.onCreated = ( typeof settings.onCreated != "function" ) ? function(){} : settings.onCreated;
            settings.onAdded   = ( typeof settings.onAdded != "function" ) ? function(){} : settings.onAdded;
            
            // Aggiorniamo i links che ci interessano
			_updateLinks();  
            
		};
        
		// Inizializzo la classe ***************************************************
		
		_lol( "Instanzio una nuova classe" );

		_setOptions( opt );

		// Se voglio utilizzare le funzioni Public Shared 'this.' devo restituire me stesso
		return this;

		// *************************************************************************

	};// Fine ClassProjectHelper

	window.GAMProjectHelper = ClassProjectHelper;

})( document );


// Chiedo al background di fornirmi i workers
chrome.runtime.sendMessage( { dialog : "GetWorkers" } );

/*
( function( helper ){
    
    if( !helper )return false;
    
    helper().DebugMode( true );
    
    var myhelper = new helper( 
        
        {

            workers : [ 

                {

                    domain  : ".bitvisitor.",
                    params  : [ 

                        {

                            param : "ref",
                            value : "123123123"

                        }

                    ]

                }

            ] 

        }

    );

    myhelper.UpdateLinks( function( href ){

        chrome.runtime.sendMessage( { dialog : "GoogleLinkHelper", link : href, page : document.location.href } );

    } );
    
    document.body.addEventListener( "DOMSubtreeModified", function() {

        myhelper.UpdateLinks();

    });
        
} )( window.GAMProjectHelper );
*/
    
    
    
    
    
    
    
    
    